/* creo la tabella di login */
create table LOGIN 
(
#id int IDENTITY(1,1)
 PRIMARY KEY CLUSTERED,
username nvarchar(20) not null,
password nvarchar(10) not null,
attivo tinyint not null CONSTRAINT df_attivo DEFAULT (0),
maxvisite int not null CONSTRAINT df_maxvisite DEFAULT (100),
date_expire datetime not null CONSTRAINT df_date_expire DEFAULT (GETDATE()+30)
);

/* creo la tabella per le statistiche */
create table LOGIN_STATS 
(
#id int identity not null,
loginID int not null FOREIGN KEY REFERENCES LOGIN(#id),
data_login datetime not null CONSTRAINT df_data_login DEFAULT (GETDATE()),
CONSTRAINT PK_login_stats PRIMARY KEY CLUSTERED( loginID, data_login ) 
);
GO
CREATE UNIQUE NONCLUSTERED INDEX uq_login ON dbo.LOGIN
	(
	username,
	password
	) ON [PRIMARY]
GO

/* inseriamo alcuni utenti di prova */
insert into LOGIN 
        ( username , password , attivo , maxvisite, date_expire ) 
        values 
        ( 'archimede' , 'pippo' , 1 , 1 , (GETDATE()-1));
insert into LOGIN 
        ( username , password , attivo , maxvisite, date_expire ) 
        values 
        ( 'pluto' , 'pippo' , 1 , 50 , (GETDATE()+30));
insert into LOGIN 
        ( username , password , attivo , maxvisite, date_expire ) 
        values 
        ( 'paperino' , 'pippo' , 1 , 10 , (GETDATE()+2));
GO

