/* Aggiorno le statistche */
create proc P_InserisciStats
 @id int
as
  insert into LOGIN_STATS ( loginID ) values ( @id )
   if @@error!=0
    return -22 -- errore nell'insert
GO

/* validazione della login */
create proc P_Login
 @username nvarchar(20),
 @password nvarchar(10),
 @err int OUTPUT,
 @numvisite int OUTPUT,
 @giornirimasti int OUTPUT
as
 declare @r int, @max int, @expire datetime, @id int, @ultimavisita datetime 
 select @id=#id, @max=maxvisite , @expire=date_expire from LOGIN 
        where username=@username and password=@password
 set @r = @@rowcount

 if @r=1 --ho un id valido comincio a controllare gli eventi
   begin
    select TOP 1 @ultimavisita=data_login, 
       @numvisite = (select count(#id) from login_stats where loginID = @id) 
       from login_stats where loginID = @id 
       order by data_login DESC   
    
    if ( @numvisite is null ) and ( @ultimavisita is null )    
     set @err = 1 -- Prima visita dell'utente
    else if (@numvisite >= @max) and ( @ultimavisita >= @expire )    
     set @err = -3
    else if (@numvisite >= @max)
     set @err = -2    
    else if ( @ultimavisita >= @expire ) 
     set @err = -1    
    else
     set @err = 0
     
    if @err=1
     begin           
      set @numvisite = 0
      set @ultimavisita = GETDATE()
     end

      set @numvisite = @max -  @numvisite
      set @giornirimasti = DATEDIFF( day , @ultimavisita , @expire )

  
    if @err = 0 OR @err = 1
     execute @r=P_InserisciStats @id
    else
     return -11 -- esco con errori da valutare

    return @r

   end 
 return -10 -- esco ID non valido  
GO